package ru.dbotthepony.mc.otm.registry;

import net.minecraft.client.renderer.blockentity.BlockEntityRenderers;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import ru.dbotthepony.mc.otm.block.entity.*;
import ru.dbotthepony.mc.otm.block.entity.blackhole.BlackHoleBlockEntity;
import ru.dbotthepony.mc.otm.block.entity.blackhole.BlockEntityExplosionDebugger;
import ru.dbotthepony.mc.otm.block.entity.blackhole.BlockEntitySphereDebugger;
import ru.dbotthepony.mc.otm.client.render.BlackHoleRenderer;
import ru.dbotthepony.mc.otm.client.render.EnergyCounterRenderer;
import ru.dbotthepony.mc.otm.client.render.GravitationStabilizerRenderer;

public class MBlockEntities {
	public static final BlockEntityType<AndroidStationBlockEntity> ANDROID_STATION = BlockEntityType.Builder.of(AndroidStationBlockEntity::new, MBlocks.ANDROID_STATION).build(null);
	public static final BlockEntityType<BatteryBankBlockEntity> BATTERY_BANK = BlockEntityType.Builder.of(BatteryBankBlockEntity::new, MBlocks.BATTERY_BANK).build(null);
	public static final BlockEntityType<MatterDecomposerBlockEntity> MATTER_DECOMPOSER = BlockEntityType.Builder.of(MatterDecomposerBlockEntity::new, MBlocks.MATTER_DECOMPOSER).build(null);
	public static final BlockEntityType<MatterCapacitorBankBlockEntity> MATTER_CAPACITOR_BANK = BlockEntityType.Builder.of(MatterCapacitorBankBlockEntity::new, MBlocks.MATTER_CAPACITOR_BANK).build(null);
	public static final BlockEntityType<MatterCableBlockEntity> MATTER_CABLE = BlockEntityType.Builder.of(MatterCableBlockEntity::new, MBlocks.MATTER_CABLE).build(null);
	public static final BlockEntityType<PatternStorageBlockEntity> PATTERN_STORAGE = BlockEntityType.Builder.of(PatternStorageBlockEntity::new, MBlocks.PATTERN_STORAGE).build(null);
	public static final BlockEntityType<MatterScannerBlockEntity> MATTER_SCANNER = BlockEntityType.Builder.of(MatterScannerBlockEntity::new, MBlocks.MATTER_SCANNER).build(null);
	public static final BlockEntityType<MatterPanelBlockEntity> MATTER_PANEL = BlockEntityType.Builder.of(MatterPanelBlockEntity::new, MBlocks.MATTER_PANEL).build(null);
	public static final BlockEntityType<MatterReplicatorBlockEntity> MATTER_REPLICATOR = BlockEntityType.Builder.of(MatterReplicatorBlockEntity::new, MBlocks.MATTER_REPLICATOR).build(null);
	public static final BlockEntityType<MatterBottlerBlockEntity> MATTER_BOTTLER = BlockEntityType.Builder.of(MatterBottlerBlockEntity::new, MBlocks.MATTER_BOTTLER).build(null);
	public static final BlockEntityType<DriveViewerBlockEntity> DRIVE_VIEWER = BlockEntityType.Builder.of(DriveViewerBlockEntity::new, MBlocks.DRIVE_VIEWER).build(null);
	public static final BlockEntityType<BlackHoleBlockEntity> BLACK_HOLE = BlockEntityType.Builder.of(BlackHoleBlockEntity::new, MBlocks.BLACK_HOLE).build(null);
	public static final BlockEntityType<CargoCrateBlockEntity> CARGO_CRATE = BlockEntityType.Builder.of(CargoCrateBlockEntity::new, MBlocks.CARGO_CRATE).build(null);
	public static final BlockEntityType<DriveRackBlockEntity> DRIVE_RACK = BlockEntityType.Builder.of(DriveRackBlockEntity::new, MBlocks.DRIVE_RACK).build(null);
	public static final BlockEntityType<ItemMonitorBlockEntity> ITEM_MONITOR = BlockEntityType.Builder.of(ItemMonitorBlockEntity::new, MBlocks.ITEM_MONITOR).build(null);
	public static final BlockEntityType<BlockEntityEnergyCounter> ENERGY_COUNTER = BlockEntityType.Builder.of(BlockEntityEnergyCounter::new, MBlocks.ENERGY_COUNTER).build(null);
	public static final BlockEntityType<ChemicalGeneratorBlockEntity> CHEMICAL_GENERATOR = BlockEntityType.Builder.of(ChemicalGeneratorBlockEntity::new, MBlocks.CHEMICAL_GENERATOR).build(null);
	public static final BlockEntityType<PlatePressBlockEntity> PLATE_PRESS = BlockEntityType.Builder.of(PlatePressBlockEntity::new, MBlocks.PLATE_PRESS).build(null);
	public static final BlockEntityType<GravitationStabilizerBlockEntity> GRAVITATION_STABILIZER = BlockEntityType.Builder.of(GravitationStabilizerBlockEntity::new, MBlocks.GRAVITATION_STABILIZER).build(null);
	public static final BlockEntityType<MatterRecyclerBlockEntity> MATTER_RECYCLER = BlockEntityType.Builder.of(MatterRecyclerBlockEntity::new, MBlocks.MATTER_RECYCLER).build(null);

	public static final BlockEntityType<BlockEntityExplosionDebugger> DEBUG_EXPLOSION_SMALL = BlockEntityType.Builder.of(BlockEntityExplosionDebugger::new, MBlocks.DEBUG_EXPLOSION_SMALL).build(null);
	public static final BlockEntityType<BlockEntitySphereDebugger> DEBUG_SPHERE_POINTS = BlockEntityType.Builder.of(BlockEntitySphereDebugger::new, MBlocks.DEBUG_SPHERE_POINTS).build(null);

	static {
		ANDROID_STATION.setRegistryName(MNames.ANDROID_STATION);
		BATTERY_BANK.setRegistryName(MNames.BATTERY_BANK);
		MATTER_DECOMPOSER.setRegistryName(MNames.MATTER_DECOMPOSER);
		MATTER_CAPACITOR_BANK.setRegistryName(MNames.MATTER_CAPACITOR_BANK);
		MATTER_CABLE.setRegistryName(MNames.MATTER_CABLE);
		PATTERN_STORAGE.setRegistryName(MNames.PATTERN_STORAGE);
		MATTER_SCANNER.setRegistryName(MNames.MATTER_SCANNER);
		MATTER_PANEL.setRegistryName(MNames.MATTER_PANEL);
		MATTER_REPLICATOR.setRegistryName(MNames.MATTER_REPLICATOR);
		MATTER_BOTTLER.setRegistryName(MNames.MATTER_BOTTLER);
		DRIVE_VIEWER.setRegistryName(MNames.DRIVE_VIEWER);
		BLACK_HOLE.setRegistryName(MNames.BLACK_HOLE);
		CARGO_CRATE.setRegistryName(MNames.CARGO_CRATE);
		DRIVE_RACK.setRegistryName(MNames.DRIVE_RACK);
		ITEM_MONITOR.setRegistryName(MNames.ITEM_MONITOR);
		ENERGY_COUNTER.setRegistryName(MNames.ENERGY_COUNTER);
		CHEMICAL_GENERATOR.setRegistryName(MNames.CHEMICAL_GENERATOR);
		PLATE_PRESS.setRegistryName(MNames.PLATE_PRESS);
		GRAVITATION_STABILIZER.setRegistryName(MNames.GRAVITATION_STABILIZER);
		MATTER_RECYCLER.setRegistryName(MNames.MATTER_RECYCLER);

		DEBUG_EXPLOSION_SMALL.setRegistryName(MNames.DEBUG_EXPLOSION_SMALL);
		DEBUG_SPHERE_POINTS.setRegistryName(MNames.DEBUG_SPHERE_POINTS);
	}

	@SubscribeEvent
	@SuppressWarnings("unused")
	public static void register(final RegistryEvent.Register<BlockEntityType<?>> event) {
		event.getRegistry().register(ANDROID_STATION);
		event.getRegistry().register(BATTERY_BANK);
		event.getRegistry().register(MATTER_DECOMPOSER);
		event.getRegistry().register(MATTER_CAPACITOR_BANK);
		event.getRegistry().register(MATTER_CABLE);
		event.getRegistry().register(PATTERN_STORAGE);
		event.getRegistry().register(MATTER_SCANNER);
		event.getRegistry().register(MATTER_PANEL);
		event.getRegistry().register(MATTER_REPLICATOR);
		event.getRegistry().register(MATTER_BOTTLER);
		event.getRegistry().register(DRIVE_VIEWER);
		event.getRegistry().register(BLACK_HOLE);
		event.getRegistry().register(CARGO_CRATE);
		event.getRegistry().register(DRIVE_RACK);
		event.getRegistry().register(ITEM_MONITOR);
		event.getRegistry().register(ENERGY_COUNTER);
		event.getRegistry().register(CHEMICAL_GENERATOR);
		event.getRegistry().register(PLATE_PRESS);
		event.getRegistry().register(GRAVITATION_STABILIZER);
		event.getRegistry().register(MATTER_RECYCLER);

		event.getRegistry().register(DEBUG_EXPLOSION_SMALL);
		event.getRegistry().register(DEBUG_SPHERE_POINTS);

		// OverdriveThatMatters.LOGGER.info("Registered block entities");
	}


	@SubscribeEvent
	@SuppressWarnings("unused")
	public static void registerRenderers(final FMLClientSetupEvent event) {
		BlockEntityRenderers.register(BLACK_HOLE, BlackHoleRenderer::new);
		BlockEntityRenderers.register(GRAVITATION_STABILIZER, GravitationStabilizerRenderer::new);
		BlockEntityRenderers.register(ENERGY_COUNTER, EnergyCounterRenderer::new);
	}
}
