package ru.dbotthepony.mc.otm.registry;

import net.minecraft.client.renderer.ItemBlockRenderTypes;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.util.valueproviders.UniformInt;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.OreBlock;
import net.minecraft.world.level.block.SoundType;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.material.Material;
import net.minecraft.world.level.material.MaterialColor;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import ru.dbotthepony.mc.otm.block.*;

public class MBlocks {
	public static final AndroidStationBlock ANDROID_STATION = new AndroidStationBlock();
	public static final BatteryBankBlock BATTERY_BANK = new BatteryBankBlock();
	public static final MatterDecomposerBlock MATTER_DECOMPOSER = new MatterDecomposerBlock();
	public static final MatterCapacitorBankBlock MATTER_CAPACITOR_BANK = new MatterCapacitorBankBlock();
	public static final BlockMatterCable MATTER_CABLE = new BlockMatterCable();
	public static final PatternStorageBlock PATTERN_STORAGE = new PatternStorageBlock();
	public static final MatterScannerBlock MATTER_SCANNER = new MatterScannerBlock();
	public static final MatterPanelBlock MATTER_PANEL = new MatterPanelBlock();
	public static final MatterReplicatorBlock MATTER_REPLICATOR = new MatterReplicatorBlock();
	public static final MatterBottlerBlock MATTER_BOTTLER = new MatterBottlerBlock();
	public static final DriveViewerBlock DRIVE_VIEWER = new DriveViewerBlock();
	public static final CargoCrateBlock CARGO_CRATE = new CargoCrateBlock();
	public static final DriveRackBlock DRIVE_RACK = new DriveRackBlock();
	public static final ItemMonitorBlock ITEM_MONITOR = new ItemMonitorBlock();
	public static final EnergyCounterBlock ENERGY_COUNTER = new EnergyCounterBlock();
	public static final ChemicalGeneratorBlock CHEMICAL_GENERATOR = new ChemicalGeneratorBlock();
	public static final PlatePressBlock PLATE_PRESS = new PlatePressBlock();
	public static final MatterRecyclerBlock MATTER_RECYCLER = new MatterRecyclerBlock();

	public static final BlockExplosionDebugger DEBUG_EXPLOSION_SMALL = new BlockExplosionDebugger();
	public static final BlockSphereDebugger DEBUG_SPHERE_POINTS = new BlockSphereDebugger();

	public static final BlackHoleBlock BLACK_HOLE = new BlackHoleBlock();
	public static final BlockGravitationStabilizer GRAVITATION_STABILIZER = new BlockGravitationStabilizer();
	public static final BlockGravitationStabilizerLens GRAVITATION_STABILIZER_LENS = new BlockGravitationStabilizerLens();

	public static final Block TRITANIUM_ORE = new OreBlock(
		BlockBehaviour.Properties.of(Material.STONE)
			.strength(3.25F, 6.0F)
			.requiresCorrectToolForDrops(),
		UniformInt.of(0, 3)
	);

	public static final Block DEEPSLATE_TRITANIUM_ORE = new OreBlock(
		BlockBehaviour.Properties.of(Material.STONE)
			.strength(4.75F, 6.5F)
			.requiresCorrectToolForDrops(),
		UniformInt.of(0, 3)
	);

	public static final Block TRITANIUM_RAW_BLOCK = new Block(
		BlockBehaviour.Properties.of(Material.STONE)
			.strength(8.0F, 10F)
			.requiresCorrectToolForDrops()
	);

	public static final Block[] CRATES = new Block[Registry.CRATES.length];

	public static final Block TRITANIUM_BLOCK = new Block(
		BlockBehaviour.Properties.of(Material.METAL, MaterialColor.COLOR_LIGHT_BLUE)
			.sound(SoundType.BASALT)
			.requiresCorrectToolForDrops()
			.explosionResistance(80)
			.strength(4)
	);

	public static final Block TRITANIUM_STRIPED_BLOCK = new Block(
		BlockBehaviour.Properties.of(Material.METAL, MaterialColor.COLOR_LIGHT_BLUE)
			.sound(SoundType.BASALT)
			.requiresCorrectToolForDrops()
			.explosionResistance(80)
			.strength(4)
	);

	public static final Block CARBON_FIBRE_BLOCK = new Block(
		BlockBehaviour.Properties.of(Material.METAL, MaterialColor.COLOR_LIGHT_BLUE)
			.sound(SoundType.BASALT)
			.requiresCorrectToolForDrops()
			.explosionResistance(40)
			.strength(3)
	);

	static {
		for (int i = 0; i < Registry.CRATES.length; i++) {
			CRATES[i] = new Block(BlockBehaviour.Properties.of(Material.METAL, Registry.CRATES[i].color())
				.sound(SoundType.METAL)
				.requiresCorrectToolForDrops()
				.strength(5.0F, 6.0F));

			CRATES[i].setRegistryName(Registry.CRATES[i].name());
		}

		TRITANIUM_ORE.setRegistryName(MNames.TRITANIUM_ORE);
		DEEPSLATE_TRITANIUM_ORE.setRegistryName(MNames.DEEPSLATE_TRITANIUM_ORE);
		TRITANIUM_RAW_BLOCK.setRegistryName(MNames.TRITANIUM_RAW_BLOCK);
		ANDROID_STATION.setRegistryName(MNames.ANDROID_STATION);
		BATTERY_BANK.setRegistryName(MNames.BATTERY_BANK);
		MATTER_DECOMPOSER.setRegistryName(MNames.MATTER_DECOMPOSER);
		MATTER_CAPACITOR_BANK.setRegistryName(MNames.MATTER_CAPACITOR_BANK);
		MATTER_CABLE.setRegistryName(MNames.MATTER_CABLE);
		PATTERN_STORAGE.setRegistryName(MNames.PATTERN_STORAGE);
		MATTER_SCANNER.setRegistryName(MNames.MATTER_SCANNER);
		MATTER_PANEL.setRegistryName(MNames.MATTER_PANEL);
		MATTER_REPLICATOR.setRegistryName(MNames.MATTER_REPLICATOR);
		MATTER_BOTTLER.setRegistryName(MNames.MATTER_BOTTLER);
		DRIVE_VIEWER.setRegistryName(MNames.DRIVE_VIEWER);
		BLACK_HOLE.setRegistryName(MNames.BLACK_HOLE);
		CARGO_CRATE.setRegistryName(MNames.CARGO_CRATE);
		DRIVE_RACK.setRegistryName(MNames.DRIVE_RACK);
		ITEM_MONITOR.setRegistryName(MNames.ITEM_MONITOR);
		ENERGY_COUNTER.setRegistryName(MNames.ENERGY_COUNTER);
		CHEMICAL_GENERATOR.setRegistryName(MNames.CHEMICAL_GENERATOR);
		PLATE_PRESS.setRegistryName(MNames.PLATE_PRESS);
		MATTER_RECYCLER.setRegistryName(MNames.MATTER_RECYCLER);

		GRAVITATION_STABILIZER.setRegistryName(MNames.GRAVITATION_STABILIZER);
		GRAVITATION_STABILIZER_LENS.setRegistryName(MNames.GRAVITATION_STABILIZER_LENS);

		DEBUG_EXPLOSION_SMALL.setRegistryName(MNames.DEBUG_EXPLOSION_SMALL);
		DEBUG_SPHERE_POINTS.setRegistryName(MNames.DEBUG_SPHERE_POINTS);

		TRITANIUM_BLOCK.setRegistryName(MNames.TRITANIUM_BLOCK);
		TRITANIUM_STRIPED_BLOCK.setRegistryName(MNames.TRITANIUM_STRIPED_BLOCK);
		CARBON_FIBRE_BLOCK.setRegistryName(MNames.CARBON_FIBRE_BLOCK);
	}

	@SubscribeEvent
	@SuppressWarnings("unused")
	public static void register(final RegistryEvent.Register<Block> event) {
		event.getRegistry().register(ANDROID_STATION);
		event.getRegistry().register(BATTERY_BANK);
		event.getRegistry().register(MATTER_DECOMPOSER);
		event.getRegistry().register(MATTER_CAPACITOR_BANK);
		event.getRegistry().register(MATTER_CABLE);
		event.getRegistry().register(PATTERN_STORAGE);
		event.getRegistry().register(MATTER_SCANNER);
		event.getRegistry().register(MATTER_PANEL);
		event.getRegistry().register(MATTER_REPLICATOR);
		event.getRegistry().register(MATTER_BOTTLER);
		event.getRegistry().register(DRIVE_VIEWER);
		event.getRegistry().register(TRITANIUM_BLOCK);
		event.getRegistry().register(TRITANIUM_STRIPED_BLOCK);
		event.getRegistry().register(CARBON_FIBRE_BLOCK);
		event.getRegistry().register(BLACK_HOLE);
		event.getRegistry().register(CARGO_CRATE);
		event.getRegistry().register(TRITANIUM_ORE);
		event.getRegistry().register(DEEPSLATE_TRITANIUM_ORE);
		event.getRegistry().register(TRITANIUM_RAW_BLOCK);
		event.getRegistry().register(DRIVE_RACK);
		event.getRegistry().register(ITEM_MONITOR);
		event.getRegistry().register(ENERGY_COUNTER);
		event.getRegistry().register(CHEMICAL_GENERATOR);
		event.getRegistry().register(PLATE_PRESS);
		event.getRegistry().register(GRAVITATION_STABILIZER);
		event.getRegistry().register(GRAVITATION_STABILIZER_LENS);
		event.getRegistry().register(MATTER_RECYCLER);

		event.getRegistry().register(DEBUG_EXPLOSION_SMALL);
		event.getRegistry().register(DEBUG_SPHERE_POINTS);

		for (var crate : CRATES) {
			event.getRegistry().register(crate);
		}

		for (var glass : Registry.INDUSTRIAL_GLASS_LIST) {
			event.getRegistry().register(glass.block());
			event.getRegistry().register(glass.pane());
		}

		// OverdriveThatMatters.LOGGER.info("Registered blocks");
	}

	@SubscribeEvent
	@SuppressWarnings("unused")
	public static void registerClient(final FMLClientSetupEvent event) {
		final var translucent = RenderType.translucent();

		for (var glass : Registry.INDUSTRIAL_GLASS_LIST) {
			ItemBlockRenderTypes.setRenderLayer(glass.block(), translucent);
			ItemBlockRenderTypes.setRenderLayer(glass.pane(), translucent);
		}
	}
}
