package ru.dbotthepony.mc.otm.registry;

import net.minecraft.client.gui.screens.MenuScreens;
import net.minecraft.world.inventory.MenuType;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import ru.dbotthepony.mc.otm.client.screen.*;
import ru.dbotthepony.mc.otm.menu.*;

public class MMenus {
	public static final MenuType<AndroidStationMenu> ANDROID_STATION = new MenuType<>(AndroidStationMenu::new);
	public static final MenuType<BatteryBankMenu> BATTERY_BANK = new MenuType<>(BatteryBankMenu::new);
	public static final MenuType<MatterDecomposerMenu> MATTER_DECOMPOSER = new MenuType<>(MatterDecomposerMenu::new);
	public static final MenuType<MatterCapacitorMenu> MATTER_CAPACITOR_BANK = new MenuType<>(MatterCapacitorMenu::new);
	public static final MenuType<PatternStorageMenu> PATTERN_STORAGE = new MenuType<>(PatternStorageMenu::new);
	public static final MenuType<MatterScannerMenu> MATTER_SCANNER = new MenuType<>(MatterScannerMenu::new);
	public static final MenuType<MatterPanelMenu> MATTER_PANEL = new MenuType<>(MatterPanelMenu::new);
	public static final MenuType<MatterReplicatorMenu> MATTER_REPLICATOR = new MenuType<>(MatterReplicatorMenu::new);
	public static final MenuType<MatterBottlerMenu> MATTER_BOTTLER = new MenuType<>(MatterBottlerMenu::new);
	public static final MenuType<DriveViewerMenu> DRIVE_VIEWER = new MenuType<>(DriveViewerMenu::new);
	public static final MenuType<CargoCrateMenu> CARGO_CRATE = new MenuType<>(CargoCrateMenu::new);
	public static final MenuType<DriveRackMenu> DRIVE_RACK = new MenuType<>(DriveRackMenu::new);
	public static final MenuType<ItemMonitorMenu> ITEM_MONITOR = new MenuType<>(ItemMonitorMenu::new);
	public static final MenuType<EnergyCounterMenu> ENERGY_COUNTER = new MenuType<>(EnergyCounterMenu::new);
	public static final MenuType<ChemicalGeneratorMenu> CHEMICAL_GENERATOR = new MenuType<>(ChemicalGeneratorMenu::new);
	public static final MenuType<MenuPlatePress> PLATE_PRESS = new MenuType<>(MenuPlatePress::new);
	public static final MenuType<MatterRecyclerMenu> MATTER_RECYCLER = new MenuType<>(MatterRecyclerMenu::new);

	static {
		ANDROID_STATION.setRegistryName(MNames.ANDROID_STATION);
		BATTERY_BANK.setRegistryName(MNames.BATTERY_BANK);
		MATTER_DECOMPOSER.setRegistryName(MNames.MATTER_DECOMPOSER);
		MATTER_CAPACITOR_BANK.setRegistryName(MNames.MATTER_CAPACITOR_BANK);
		PATTERN_STORAGE.setRegistryName(MNames.PATTERN_STORAGE);
		MATTER_SCANNER.setRegistryName(MNames.MATTER_SCANNER);
		MATTER_PANEL.setRegistryName(MNames.MATTER_PANEL);
		MATTER_REPLICATOR.setRegistryName(MNames.MATTER_REPLICATOR);
		MATTER_BOTTLER.setRegistryName(MNames.MATTER_BOTTLER);
		DRIVE_VIEWER.setRegistryName(MNames.DRIVE_VIEWER);
		CARGO_CRATE.setRegistryName(MNames.CARGO_CRATE);
		DRIVE_RACK.setRegistryName(MNames.DRIVE_RACK);
		ITEM_MONITOR.setRegistryName(MNames.ITEM_MONITOR);
		ENERGY_COUNTER.setRegistryName(MNames.ENERGY_COUNTER);
		CHEMICAL_GENERATOR.setRegistryName(MNames.CHEMICAL_GENERATOR);
		PLATE_PRESS.setRegistryName(MNames.PLATE_PRESS);
		MATTER_RECYCLER.setRegistryName(MNames.MATTER_RECYCLER);
	}

	@SubscribeEvent
	@SuppressWarnings("unused")
	public static void register(final RegistryEvent.Register<MenuType<?>> event) {
		event.getRegistry().register(ANDROID_STATION);
		event.getRegistry().register(BATTERY_BANK);
		event.getRegistry().register(MATTER_DECOMPOSER);
		event.getRegistry().register(MATTER_CAPACITOR_BANK);
		event.getRegistry().register(PATTERN_STORAGE);
		event.getRegistry().register(MATTER_SCANNER);
		event.getRegistry().register(MATTER_PANEL);
		event.getRegistry().register(MATTER_REPLICATOR);
		event.getRegistry().register(MATTER_BOTTLER);
		event.getRegistry().register(DRIVE_VIEWER);
		event.getRegistry().register(CARGO_CRATE);
		event.getRegistry().register(DRIVE_RACK);
		event.getRegistry().register(ITEM_MONITOR);
		event.getRegistry().register(ENERGY_COUNTER);
		event.getRegistry().register(CHEMICAL_GENERATOR);
		event.getRegistry().register(PLATE_PRESS);
		event.getRegistry().register(MATTER_RECYCLER);

		// OverdriveThatMatters.LOGGER.info("Registered menus");
	}

	@SubscribeEvent
	@SuppressWarnings("unused")
	public static void registerScreens(final FMLClientSetupEvent event) {
		MenuScreens.register(ANDROID_STATION, AndroidStationScreen::new);
		MenuScreens.register(BATTERY_BANK, BatteryBankScreen::new);
		MenuScreens.register(MATTER_DECOMPOSER, MatterDecomposerScreen::new);
		MenuScreens.register(MATTER_CAPACITOR_BANK, MatterCapacitorBankScreen::new);
		MenuScreens.register(PATTERN_STORAGE, PatternStorageScreen::new);
		MenuScreens.register(MATTER_SCANNER, MatterScannerScreen::new);
		MenuScreens.register(MATTER_PANEL, MatterPanelScreen::new);
		MenuScreens.register(MATTER_REPLICATOR, MatterReplicatorScreen::new);
		MenuScreens.register(MATTER_BOTTLER, MatterBottlerScreen::new);
		MenuScreens.register(DRIVE_VIEWER, DriveViewerScreen::new);
		MenuScreens.register(CARGO_CRATE, CargoCrateScreen::new);
		MenuScreens.register(DRIVE_RACK, DriveRackScreen::new);
		MenuScreens.register(ITEM_MONITOR, ItemMonitorScreen::new);
		MenuScreens.register(ENERGY_COUNTER, EnergyCounterScreen::new);
		MenuScreens.register(CHEMICAL_GENERATOR, ChemicalGeneratorScreen::new);
		MenuScreens.register(PLATE_PRESS, PlatePressScreen::new);
		MenuScreens.register(MATTER_RECYCLER, MatterRecyclerScreen::new);

		// OverdriveThatMatters.LOGGER.info("Registered screens");
	}
}
